// This file has been written by Jiri Bittner, October 2006

#ifndef __BVHLOADER_H
#define __BVHLOADER_H

#include "Bvh.h"

class igzstream;


namespace CHCDemoEngine
{

/** Loader for a bounding volume hierarchy.
*/
class BvhLoader
{
public:
	/** Creates and loads bvh with static and dynamic objects.
		The static part of the hierarchy is loaded from the disc,
		the dynamic part is created and changed on the fly.
	*/
	Bvh *Load(const std::string &filename, 
			  const SceneEntityContainer &staticEntities,
			  const SceneEntityContainer &dynamicEntities);

protected:
	
	BvhNode *LoadNextNode(igzstream &stream, BvhInterior *parent);
};

}

#endif // __BVHLOADER_H